# main.py
from lcd import LCD_3inch5
from touch import Touch
import time
 
PICO_RP2040 = True
PICO_RP2350 = not PICO_RP2040

def main():
    LCD = LCD_3inch5()
    TOUCH =Touch()
    LCD.bl_ctrl(100)
    LCD.fill(LCD.BLACK)
    LCD.show_up()
    LCD.fill(LCD.BLACK)
    LCD.show_down()
    if LCD.rotate == 0 or LCD.rotate == 180: #Determining the display direction
        #color BRG     
        LCD.fill(LCD.WHITE)
        LCD.fill_rect(60,75,200,30,LCD.RED)
        LCD.text("Raspberry Pi Pico",90,87,LCD.WHITE)
        display_color = 0x001F
        LCD.text("3.5' IPS LCD TEST",90,127,LCD.BLACK)
        for i in range(0,12):      
            LCD.fill_rect(i*20+35,170,30,120,(display_color))
            display_color = display_color << 1
        LCD.show_up()
        
        LCD.fill(LCD.WHITE)
        LCD.show_down()
        while True:
            get = TOUCH.touch_get() 
            if get != None:
                if PICO_RP2040:
                    X_Point = int((get[1]-430)*480/3270)
                    Y_Point = 320-int((get[0]-430)*320/3270)
                elif PICO_RP2350:
                    X_Point = int((get[1]-4500)*480/3360)
                    Y_Point = 320-int((get[0]-4480)*320/3500)
                if(X_Point>480):
                    X_Point = 480
                elif X_Point<0:
                    X_Point = 0
                if(Y_Point>320):
                    Y_Point = 320
                elif Y_Point<0:
                    Y_Point = 0
                if LCD.rotate == 0 :
                    if(X_Point<120):
                        LCD.fill(LCD.WHITE)
                        if(Y_Point<90):
                            LCD.fill_rect(10,150,75,50,LCD.RED)
                            LCD.text("Button0",20,170,LCD.WHITE)
                        elif(Y_Point<160):
                            LCD.fill_rect(85,150,75,50,LCD.RED)
                            LCD.text("Button1",100,170,LCD.WHITE)
                        elif(Y_Point<240):
                            LCD.fill_rect(160,150,75,50,LCD.RED)
                            LCD.text("Button2",175,170,LCD.WHITE)
                        else:
                            LCD.fill_rect(235,150,75,50,LCD.RED)
                            LCD.text("Button3",250,170,LCD.WHITE)
                else:
                    if(X_Point>360):
                        LCD.fill(LCD.WHITE)
                        if(Y_Point<90):
                            LCD.fill_rect(235,150,75,50,LCD.RED)
                            LCD.text("Button3",250,170,LCD.WHITE)                     
                        elif(Y_Point<160):
                            LCD.fill_rect(160,150,75,50,LCD.RED)
                            LCD.text("Button2",175,170,LCD.WHITE)                         
                        elif(Y_Point<240):
                            LCD.fill_rect(85,150,75,50,LCD.RED)
                            LCD.text("Button1",100,170,LCD.WHITE)
                        else:
                            LCD.fill_rect(10,150,75,50,LCD.RED)
                            LCD.text("Button0",20,170,LCD.WHITE)
            else :
               LCD.fill(LCD.WHITE)                     
               LCD.text("Button0",20,170,LCD.BLACK)
               LCD.text("Button1",100,170,LCD.BLACK)
               LCD.text("Button2",175,170,LCD.BLACK)
               LCD.text("Button3",250,170,LCD.BLACK)   
            LCD.show_down()  
            time.sleep(0.1)

    else:
        #color BRG     
        LCD.fill(LCD.WHITE)
        LCD.fill_rect(140,5,200,30,LCD.RED)
        LCD.text("Raspberry Pi Pico",170,17,LCD.WHITE)
        display_color = 0x001F
        LCD.text("3.5' IPS LCD TEST",170,57,LCD.BLACK)
        for i in range(0,12):      
            LCD.fill_rect(i*30+60,100,30,50,(display_color))
            display_color = display_color << 1
        LCD.show_up()
        
        LCD.fill(LCD.WHITE)
        LCD.show_down()
        
        while True:      
            get = TOUCH.touch_get()
            if get != None: 
                if PICO_RP2040:
                    X_Point = int((get[1]-430)*480/3270)
                    Y_Point = 320-int((get[0]-430)*320/3270)
                elif PICO_RP2350:
                    X_Point = int((get[1]-4500)*480/3360)
                    Y_Point = 320-int((get[0]-4480)*320/3500)
                if(X_Point>480):
                    X_Point = 480
                elif X_Point<0:
                    X_Point = 0
                if(Y_Point>320):
                    Y_Point = 320
                elif Y_Point<0:
                    Y_Point = 0
# When the rotation is 90°, remove the comment below, and the touch rotation at 270° can be annotated
# 90° touch rotation is enabled by default
                if(Y_Point<120):
                    LCD.fill(LCD.WHITE)
                    if(X_Point<120):
                        LCD.fill_rect(360,60,120,100,LCD.RED)
                        LCD.text("Button3",400,110,LCD.WHITE)
                    elif(X_Point<240):
                        LCD.fill_rect(240,60,120,100,LCD.RED)
                        LCD.text("Button2",270,110,LCD.WHITE)
                    elif(X_Point<360):
                        LCD.fill_rect(120,60,120,100,LCD.RED)
                        LCD.text("Button1",150,110,LCD.WHITE)          
                    else:               
                        LCD.fill_rect(0,60,120,100,LCD.RED)
                        LCD.text("Button0",20,110,LCD.WHITE)
# When the rotation is 270°, remove the comment below, and the touch rotation at 90° can be annotated
                                 
#                 if(Y_Point>220):
#                     LCD.fill(LCD.WHITE)
#                     if(X_Point<120):
#                         LCD.fill_rect(0,60,120,100,LCD.RED)
#                         LCD.text("Button0",20,110,LCD.WHITE)
#                     elif(X_Point<240):
#                         LCD.fill_rect(120,60,120,100,LCD.RED)
#                         LCD.text("Button1",150,110,LCD.WHITE)
#                     elif(X_Point<360):
#                         LCD.fill_rect(240,60,120,100,LCD.RED)
#                         LCD.text("Button2",270,110,LCD.WHITE)
#                     else:
#                         LCD.fill_rect(360,60,120,100,LCD.RED)
#                         LCD.text("Button3",400,110,LCD.WHITE)           
            else :
               LCD.fill(LCD.WHITE)
               LCD.text("Button0",20,110,LCD.BLACK)
               LCD.text("Button1",150,110,LCD.BLACK)
               LCD.text("Button2",270,110,LCD.BLACK)
               LCD.text("Button3",400,110,LCD.BLACK)         
            LCD.show_down()  
            time.sleep(0.1)
               


if __name__ == "__main__":
    main()

